'*******************************************************************************
'*   Gemeinsame Funktionen von RX und TX Steuerung                             *
'*******************************************************************************
' 17.12.2015: Bushnger und Kollisionen abgefangen Debugs entfernt
' 15.05.2015: StepFaktor auf 128 erweitert
'*******************************************************************************
'*   Menue Haupt Funktion                                                      *
'*******************************************************************************
Sub Menue(byref Menuenr As Byte , Byval Maxmenue As Byte)
   Mmenue:
      Do
         Cls
         Lcd Zeilenarray(menuenr)
         Lowerline
         If Menuenr = Maxmenue Then
            Temp = 1
         Else
            Temp = Menuenr + 1
         End If
         Lcd Zeilenarray(temp)
         Gosub Tasten_pause                                       ' Tastenbremse
         Gosub Tastaturabfrage
         If Plus = 1 Then
            Incr Menuenr
            If Menuenr > Maxmenue Then Menuenr = 1
         End If
         If Minus = 1 Then
            Decr Menuenr
            If Menuenr = 0 Then Menuenr = Maxmenue
         End If
         If Ok > 0 Or Restart = 1 Then Exit Sub
      Loop
End Sub
'*******************************************************************************
'*  QRG Auf/Ab Routine                                                         *
'*******************************************************************************
Sub Auf_ab(byref Parameter As Dword , byref Step_khz As Word , byref Faktor_step As Byte , byref Faktor As Byte , byref Lo_p_m As Byte , byref Lo_x As Word , Byval Pmax As Dword , Byval Pmin As Dword , Byval Ptrx As String)
   Do
      Cls
      Lcd Ptrx
      Locate 2 , 1
      Parameter_temp = Parameter * Faktor
      Parameter_temp1 = Lo_x * 1000
      Select Case Lo_p_m
         Case 1
            Parameter_temp = Parameter_temp1 + Parameter_temp
         Case 2
            Parameter_temp = Parameter_temp1 - Parameter_temp
      End Select
      Parameter_temp1 = Parameter_temp / 1000
      Lcd Parameter_temp1
      Lcd "."
      Parameter_temp1 = Parameter_temp Mod 1000
      If Parameter_temp1 < 100 Then Lcd "0"
      If Parameter_temp1 < 10 Then Lcd "0"
      Lcd Parameter_temp1
      Gosub Alles_ausgeben
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Tastaturabfrage
      If Restart = 1 Then                                      ' Rcksprung in Menue-> hier bleiben
         Restart = 0
      End If
      If Plus = 1 Then
         Parameter_temp = Step_khz * Faktor_step
         Parameter = Parameter + Parameter_temp
         If Parameter > Pmax Then Parameter = Pmin
         Gosub Trx_fram_schreiben
      End If
      If Minus = 1 Then
         Parameter_temp = Step_khz * Faktor_step
         Parameter = Parameter - Parameter_temp
         If Parameter < Pmin Then Parameter = Pmax
         Gosub Trx_fram_schreiben
      End If
      If Ok > 0  Then Exit Sub                                      'Kein restart=1 weil das Menue ja dauerhaft sein soll
   Loop
End Sub
'*******************************************************************************
'*  Step_real Auf/Ab Routine                                                   *
'*******************************************************************************
Sub Step_einstellung(byref Stepxfaktor As Byte , Byref Stepxkhz As Word , Byval Stepxtrx As String , Byval Step__einheit As String)
   Do
      Cls
      Lcd Stepxtrx
      Locate 2 , 1
      Temp_w = Stepxkhz * Stepxfaktor
      Lcd Temp_w
      Lcd Step__einheit
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Trx_fram_schreiben
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Stepxfaktor = Stepxfaktor * 2                         ' 2*128 = 0 !!!!
         If Stepxfaktor < 1 Then Stepxfaktor = 1
      End If
      If Minus = 1 Then
         Stepxfaktor = Stepxfaktor / 2
         If Stepxfaktor < 1 Then Stepxfaktor = 128
      End If
      If Ok = 2 Then Gosub Step_referenz
      If Ok = 1 Or Restart = 1 Then Exit Sub
   Loop
   'hier kommt ma nie vorbei nur durch Sprung
   Step_referenz:
      Temp_step = 1
      Temp_w = Stepxkhz
      Do
         Cls
         Lcd "Step Ref"
         Lowerline                                                ' 2. Zeile
         Lcd Temp_w
         Lcd Khz
         Gosub Tasten_pause                                       'Tastenbremse
         Gosub Tastaturabfrage
         If Plus = 1 Then
            Temp_w = Temp_w + Temp_step
         End If
         If Minus = 1 Then
            Temp_w = Temp_w - Temp_step
         End If
         If Ok = 2 Then                                           ' wenn Menue-Taste lnger gedrckt ist
            Temp_step = Temp_step * 10                             ' dann nchste Dezimalstelle einstellen
            If Temp_step > 1000 Then Temp_step = 1
         End If
         If Ok = 1 Or Restart = 1 Then
            Ok = 0                                                ' sonst springt man gleich 2 Ebenen hher
            Stepxkhz = Temp_w
            Gosub Trx_fram_schreiben
            Return
         End If
      Loop
   Return
End Sub
'*******************************************************************************
'*   Nummer Auf/Ab Routine                                                     *
'*******************************************************************************
Sub Nr_auf_ab(byref Nr_parameter As Byte , Byval Nr_step As Byte , Byval Nr_pmax As Byte , Byval Nr_pmin As Byte , Byval Nt_trx As String)
   Do
      Cls
      Lcd Nt_trx
      Locate 2 , 1
      Lcd Nr_parameter
      Gosub Tasten_pause                                       'Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Nr_parameter = Nr_parameter + Nr_step
         If Nr_parameter > Nr_pmax Then Nr_parameter = Nr_pmin
      End If
      If Minus = 1 Then
         Nr_parameter = Nr_parameter - Nr_step
         If Nr_parameter < Nr_pmin Then Nr_parameter = Nr_pmax
      End If
      If Ok > 0 Or Restart = 1 Then Exit Sub
   Loop
End Sub
'*******************************************************************************
'*   Step Auf/Ab Routine                                                       *
'*******************************************************************************
Sub Step_auf_ab(byref Step_parameter As Word , Byval Step_step As Word , Byval Step_pmax As Word , Byval Step_pmin As Word , Byval Step_trx As String , Byval Step_einheit As String)
   Do
      Cls
      Lcd Step_trx
      Locate 2 , 1
      Lcd Step_parameter
      Lcd Step_einheit
      'Locate 2 , 8
      'If I2c_err = 1 Then                                   ' Bei I2C-Fehler "E" anzeigen
      '   Lcd "E"
      'Else
      '   Lcd "."
      'End If
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Step_parameter = Step_parameter + Step_step
         If Step_parameter > Step_pmax Then Step_parameter = Step_pmin
      End If
      If Minus = 1 Then
         Step_parameter = Step_parameter - Step_step
         If Step_parameter < Step_pmin Then Step_parameter = Step_pmax
      End If
      If Ok = 2 Then                                           ' wenn Menue-Taste lnger gedrckt ist
         Step_step = Step_step * 10                             ' dann nchste Dezimalstelle einstellen
         If Step_step > 1000 Then Step_step = 1
      End If
      If Ok = 1 Or Restart = 1 Then Exit Sub
      Gosub S_Sonder
   Loop
End Sub
'*******************************************************************************
'*   Bit ein aus  Routine                                                      *
'*******************************************************************************
Sub Bit_ein_aus(byref Bit_parameter As Byte , Byval Anzeige_bit As String , Byval Max_zustand As Byte , Byval Lcd0 As String , Byval Lcd1 As String , Byval Lcd2 As String )
   Do
      Cls
      Lcd Anzeige_bit
      Locate 2 , 1
      Select Case Bit_parameter
         Case 0
            Lcd Lcd0
         Case 1
            Lcd Lcd1
         Case Else
            Lcd Lcd2
      End Select
      Gosub Tasten_pause                                       'Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Or Minus = 1 Then
         Incr Bit_parameter
         If Bit_parameter > Max_zustand Then Bit_parameter = 0
      End If
      If Ok > 0 Or Restart = 1 Then  Exit Sub
   Loop
End Sub
'*******************************************************************************
'*   Tastaturabfrage raus kommt: Plus=1 Minus=1 OK=1 oder OK=2                 *
'*******************************************************************************
Tastaturabfrage:
   Ok_cnt = 0
   Plus = 0
   Minus = 0
   Ok = 0
   Do
      Gosub T_Sonder
      If T_auf = 0 Then                                         ' Auf-Abfrage
         Plus = 1
         Exit Do
      End If
      If T_ab = 0 Then                                          ' Ab-Abfrage
         Minus = 1
         Exit Do
      End If
      If T_menu = 0 Then                                        ' Menue-Abfrage Taste kann lnger gedrckt werden
         Ok = 1
         Do                                                     ' Zhlschleife
            Incr Ok_cnt
            Waitms 1                                            ' in 1 ms Schritten
         Loop Until T_menu = 1                                  ' Ablauf wird angehalten bis Taste losgelassen
         If Ok_cnt > 500 Then                                   ' wenn lnger als 500msgedrckt, dann
            Ok = 2
         End If
         Exit Do
      End If
      ' raus wenn Frams neu gelesen werden sollen
      If x_use_fram = 1 Then
         If Fram_timer_flag = 1 Then
            Fram_timer_flag = 0
            Gosub Trx_fram_lesen                                 ' Fram lesen und Prfen
         else
            Gosub Sdcl_test                                      ' Prfen ob Leitungen ok sind
         End If
      end if
      ' raus wenn Menue-Timeout
      If Menue_timer_flag = 1 or Restart = 1 Then                ' Bei keinem Tastendruck zurck ins oberste Menue
         Menue_timer_flag = 0
         xMenueNr = 1
         Restart = 1
         Exit Do
      End If
      If Refresh = 1 Then
         Refresh = 0
         Return
      End If
   Loop
   Menue_timer_cnt = Menue_timeout                             ' Menue-Timer wiederauffllen
Return
'*******************************************************************************
'*   SDA und SCl berprfen und ggf PCA Resetten                               *
'*******************************************************************************
Sdcl_test:
   TWCR = &B00000000
   Config Pinc.4 = Input
   Config Pinc.5 = Input
   If T_sda = 0 Then
      Waitms 5
      If T_sda = 0 Then
         Sda_scl_pc = Sda_scl_pc + 1
      End If
   End If
   If T_scl = 0 Then
      Waitms 5
      If T_scl = 0 Then
         Sda_scl_pc = Sda_scl_pc + 1
      End If
   End If
   If T_sda = 1 And T_scl = 1 Then
      Sda_scl_pc = 0
   End If
   If Sda_scl_pc > 350 Then                                ' mu wirklich fast 1 Minute down sein
      Sda_scl_pc = 0
      Config Pinc.5 = Output
      for i = 0 to 8
         T_scl = 0                                         ' fehlende SCLs bei Eeproms nachschieben
         waitms 3
         T_scl = 1
         waitms 3
      next
      Config Pinc.4 = Input
      Config Pinc.5 = Input
   End If
   Twcr = &B00000100                                      '
Return
'*******************************************************************************
'*    Tasten pause zum Code sparen                                             *
'*******************************************************************************
Tasten_pause:
   Waitms 175
Return
'*******************************************************************************
'*    IC-Multimaster ISR                                                      *
'*******************************************************************************
'+++++++++++++++++++++++++++++
'+ MultiMaster RX/TX Routine +
'++++++++++++++++++++++++++++++
Run_wait_master:                                            ' passt nimmer in den Proz ....
   Gosub Mst_start                                          ' Aufruf ( da drin passierts!!)
   Select Case Twi_mst_flag                                 ' Ergebnis ?
      Case Twi_m_sent:                                      ' (1) gesendet
         Twi_mst_flag = 0
      Case Twi_m_recv:                                      ' (2) geholt
         Twi_mst_flag = 0
      Case Else                                             ' irgendein Problem z.B. (3)=timeout
         Incr Twi_fehler_cnt                                ' Fehlerzhler
         Twcr = &B00000000
         Config Pinc.5 = Input
         Config Pinc.4 = Input
         Twcr = &B00000100
   End Select
Return
'*******************************************************************************
'*    Timerkonfiguration                                                       *
'*******************************************************************************
'+++++++++++++++++++++++++++
'+ Timer0 fr Fram-Abfrage +
'+++++++++++++++++++++++++++
Fram_timer:                                                 ' Timer1 Auswertung
   Decr Fram_timer_cnt
   If Fram_timer_cnt = 0 Then
      Fram_timer_cnt = Fram_timeout
      Fram_timer_flag = 1                                   ' Timerflag nach dem Lesen wieder  0 setzen
   End If
Return
'++++++++++++++++++++++++
'+ Timer1 fr Drehgeber +                                   ' noch nicht verwendet
'++++++++++++++++++++++++

'+++++++++++++++++++++++++++++
'+ Timer2 fr Menue-Ausstieg +
'+++++++++++++++++++++++++++++
Menue_timer:                                                ' Timer2 Auswertung
   Decr Menue_timer_cnt
   If Menue_timer_cnt = 0 Then
      Menue_timer_cnt = Menue_timeout
      Menue_timer_flag = 1                                ' Timerflag nach dem Lesen wieder  0 setzen
   End If
Return